#ifndef LINEDIT_WITH_KEYBOARD
#define LINEDIT_WITH_KEYBOARD
#include <QWidget>
#include <QLineEdit>
#include "keyboard.h"

class LineEditWithKeyboard : public QLineEdit
{
    Q_OBJECT
public:
    LineEditWithKeyboard(QWidget *parent = nullptr);

protected:
    void mousePressEvent(QMouseEvent *event);

signals:
    void signalMousePressed();

public slots:
    void slotWordChoose(QString word);

private:
    void keyPressEvent(QKeyEvent* event);

    keyboard* m_keyboard;
};

#endif // LINEDIT_WITH_KEYBOARD
